package com.BASeCamp.SurvivalChests;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.BlockState;
import org.bukkit.block.Chest;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import java.io.File;
import java.io.IOException;
import java.util.*;

import com.BASeCamp.SurvivalChests.BCRandomizer;
import com.BASeCamp.SurvivalChests.RandomData;


public class ChestRandomizer {

	
	private Chest mchest;
	private Inventory mInventory;
	private int _MinItems = 1;
	private int _MaxItems = 10;
	public int getMinItems() { return _MinItems;}
	public void setMinItems(int value){_MinItems = value;}
	public int getMaxItems() { return _MaxItems;}
	public void setMaxItems(int value) { _MaxItems=value;}
	private static LinkedList<RandomData> randData = null;
	public static LinkedList<RandomData> addall = null; //items that will always be added once.
	public ChestRandomizer(Chest pChest){
		mchest=pChest;
		mInventory = mchest.getBlockInventory();
		if(randData==null)
		{
			reload();
			
			
		}
	}
	public ChestRandomizer(Inventory sourceinventory){
		
		mchest = null;
		mInventory = sourceinventory;
		if(randData==null)
		{
			reload();
			
			
		}
		
	}
	private void reload()
	{
		randData = new LinkedList<RandomData>();
		addall= new LinkedList<RandomData>();
		try {
		if(new File(BCRandomizer.pluginConfigLocation).exists()){
			//read each line.
			Scanner sc = new Scanner(new File(BCRandomizer.pluginConfigLocation));
			
			while(sc.hasNextLine()){
				String lineread = sc.nextLine();
				if(!(lineread.startsWith("//")||lineread.trim().length()==0)){
					if(lineread.startsWith("STATIC:")){
					    lineread = lineread.substring(7);	
					    RandomData staticdata = new RandomData(lineread);
					    addall.add(staticdata);
					}
					else {
					
				RandomData gendata = new RandomData(lineread);
				randData.add(gendata);
					}
				}
				
			}
			
		}
		System.out.println("Read in " + randData.size() + " elements");
		}
		catch(IOException iox)
		{
			System.err.println("IOException accessing file " + BCRandomizer.pluginConfigLocation);
		}
		
		
		
		
	}
	public void clear()
	{
		
		Inventory gotinventory = mchest.getBlockInventory();
		//OK, loop the appropriate number of times, choose a randomData and generate it.
		gotinventory.clear();	
	
	}
	private Integer[] emptyslots(Inventory inv){
		Integer[] createit = new Integer[inv.getSize()];
		int currempty = 0;
		for(int i=0;i<inv.getSize();i++){
			if(inv.getItem(i)==null || inv.getItem(i).getTypeId()==0)
				createit[currempty]=new Integer(i);
			currempty++;
			
		}
		return createit;
		
		
		
	}
	public int Shuffle()
	{
		
		
		//if the block beneath the chest is wool, break out. We don't randomize chests with wool underneath.
		if(mchest!=null){
			Location chestspot = mchest.getLocation();
			Location spotbelow = new Location(mchest.getWorld(), chestspot.getX(), chestspot.getY()-1, chestspot.getZ());
			if(mchest.getWorld().getBlockAt(spotbelow).getType()==Material.WOOL){
			return 0;	
			}
		}
		
		
		//select a random number of items.
		int _numgenerate=0;
		if(_MaxItems==_MinItems) _numgenerate = _MaxItems; else
		_numgenerate = RandomData.rgen.nextInt(_MaxItems-_MinItems)+_MinItems;
		
		
		Inventory gotinventory = mInventory;
		//OK, loop the appropriate number of times, choose a randomData and generate it.
		gotinventory.clear();
		System.out.println("Minitems:" + _MinItems + "MaxItems " + _MaxItems + "Gen:" + _numgenerate);
		
		for(int i=1;i<_numgenerate;i++){
			RandomData rdata = RandomData.ChooseRandomData(randData);
			if(rdata!=null){
				
				ItemStack created = rdata.Generate();
				if(created!=null)
				{
				//get all empty slots.
					Integer[] empties = emptyslots(gotinventory);
					Integer selectedslot = RandomData.Choose(empties);
					if(selectedslot!=null){
					gotinventory.setItem(selectedslot,created);
					}
					else {
				    gotinventory.addItem(created);
					}
					
				}
			}
		
		}
		return gotinventory.getContents().length;
		
	}
}
